;  Switch Off Timer (SWO)
;=========================
;switch off connected device after:
.equ	TIME = 90 ;minutes [1..255]
;
;ATTiny11L @ 1MHz (internal R/C)
;
;PORTS:
;  PB0 = Output (high while and TIME minutes after input is high)
;  PB1 = Input
;
;VERSION HISTORY
;1.0  2005-09-01  Arne Rossius


.include "../include/tn11def.inc"

.def	temp = R16
.def	wait1 = R17
.def	wait2 = R18
.def	wait3 = R19
.def	wait4 = R20
.def	wait5 = R21

.cseg
.org 0x000
	rjmp	start
	
start:
	;init ports
	ldi	temp, 0x01
	out	DDRB, temp
	ldi	temp, 0x1C
	out	PORTB, temp
	
switch_on:
	;switch device on if input is 1
	sbic	PINB, 1
	sbi	PORTB, 0
	
stay_on:
	;wait until input is 0
	sbic	PINB, 1
	rjmp	stay_on
	
	;wait for TIME minutes
	clr	wait1
	clr	wait2
	ldi	wait3, 182
	ldi	wait4, TIME
wait:
	sbic	PINB, 1 ;jump back if input is 1 again
	rjmp	stay_on
	dec	wait1
	brne	wait
	nop
	nop
	nop
	nop
	nop
	dec	wait2
	brne	wait
	dec	wait3
	brne	wait
	ldi	wait3, 182
	dec	wait4
	brne	wait
	
	;switch device off
	cbi	PORTB, 0
	
stay_off:
	;wait until input is 1
	sbis	PINB, 1
	rjmp	stay_off
	
	;jump to beginning
	rjmp	switch_on